      double precision function pcq12d(j,i,x,y)
c .........................................................
c     polynomes de base du quadrilatere q2 a 9 noeuds
c            j = 0 : fonction
c            j = 1 : derivee par rapport a x
c            j = 2 : derivee par rapport a y
c     element de reference [-1,1]*[-1,1]
c          
c .........................................................
      double precision xref(4),yref(4),x,y
      data xref / -1,1,1,-1/
      data yref / -1, -1,1,1/
c
c     la fonction
c     ------------

      if (j .eq. 0) then 

         pcq12d = 0.25*(1+xref(i)*x)*(1+yref(i)*y)
c
c      la derivee par rapport a x
c      --------------------------

      else if (j .eq. 1) then 

         pcq12d = 0.25*xref(i)*(1+yref(i)*y)

c
c      la derivee par rapport a y
c      --------------------------

      else if (j .eq. 2) then 

         pcq12d =  0.25*yref(i)*(1+xref(i)*x)

      endif
      end
